/*  author: G. Matas                           (g.matas@ee.surrey.ac.uk)
*/
/* +-------------------------------------------------------------------+ */
/* | Copyright 1992, George Matas.                                     | */
/* |   Permission to use, copy, modify, and distribute this software   | */
/* |   and its documentation for any purpose and without fee is hereby | */
/* |   granted, provided that the above copyright notice appear in all | */
/* |   copies and that both that copyright notice and this permission  | */
/* |   notice appear in supporting documentation.  This software is    | */
/* |   provided "as is" without express or implied warranty.           | */
/* +-------------------------------------------------------------------+
*/
/*-----------------------------------------------------------------------*/
static char sccsid[]="@(#)93/06/30 g.matas@ee.surrey.ac.uk 5.1 ex1.c";



#include "LL.h"
#include <stdio.h>
#include <string.h>

/*-- An example of double linked list (LL) functions for strings  -------*/
/*  Author : G. Matas                           date: 3.1.92             */
/*             (g.matas@ee.surrey.ac.uk)                                 */
/*  Changes: 
**
**-----------------------------------------------------------------------*/

int strcasecmp(char * , char *);


void * pr(void *el);          /* print a string given a pointer to elem  */

int AdrAlfCompC(const void *el1,const  void *el2); 
				/* comparisons for SortAdr   */
int AdrAlfComp(const void *el1, const void *el2);
int AlfComp(const void *el1, const void *el2);
int AlfCompC(const void *el1, const void *el2);


/*  Insert all arguments of the program into a LL list and do some tricks */
/*  example call:   example1  Eve Adam you me I                           */

int main (int argc, char ** argv)
{
  t_LL list =  ConsLL();
  char **el;
  char * Message1 = "Mess1";
  char * Message2 = "Mess2";
  char * Message3 = "Mess3";



  while (argc-->0){
   InsLastLL(list,argv[argc]);
  }

  printf("\nWhat is in the list?\n");
  ForeachLL_M(list,el)
   printf("%s  ",*el);
  printf("\n");

  InsFirstLL(list,Message1);
  InsLastLL(list,Message2);
  InsBefLL(NthElmLL(list,4),Message3);

  printf("\nMessages 1,2 and 3 added:\n");
  ForeachLL_M(list,el)
       printf("%s  ",*el);
  printf("\n");

  DelElmLL(PrevElmLL(NthElmLL(list,4)));

  printf("\n3rd element deleted:\n");
  ApplyLL(list,pr);
  printf("\n");


  InsLastLL(list,Message1);
  InsBefLL( LastElmLL(list),Message2);
  printf("\nMessage 1 added as last, Message2 as penultimate\n");
  ApplyLL(list,pr);
  printf("\n");

  printf("Size of list: %d\n", SizeLL(list));

  SortLL(list, AlfComp);
  printf("\nSort (using SortLL) case sensitive \n");
  ApplyLL(list,pr);
  printf("\n");

  SortLL(list,  AlfCompC);
  printf("\nSort (using SortLL) case insensitive \n");
  ApplyLL(list,pr);
  printf("\n");

  el = NthElmLL(list,4);
  printf("fourth elm: %s \n",*el);

  SortLL(list,  AlfComp);
  printf("\nSort (using SortLL) case sensitive \n");
  ApplyLL(list,pr);
  printf("\n");

  printf("the originally fourth elm (address unchanged by Sort): %s \n\n",*el);

  EmptyLL(list);
  printf("After EmptyLL\n");
  ApplyLL(list,pr);
  printf("\n"); 
  printf("Size of list: %d\n", SizeLL(list));
 
  DestLL(list);        /* clean up and quit */
  return 0;
}
   
void * pr(void *el)        /* print one elem  */
{
 printf("%s  ",*(char**)el);
 return NULL;
}

/* comparison functions Called from SortLL (SortLL <if addr in name>)    */

int AdrAlfCompC(const void *el1, const void *el2)  \
{                                     /* for SortAdrLL, case insens. */
  return strcasecmp(**(char** const *) el1, **(char** const *) el2);
}

int AdrAlfComp(const void *el1, const void *el2)
{                                     /* for SortAdrLL, case sensit. */
  return strcmp(**(char ** const *) el1, **(char ** const *) el2);
}

int AlfComp(const void *el1, const void *el2)
{                                      /* for SortLL, case sensitive  */
  return strcmp(*(char * const *) el1, *(char * const *) el2);
}

int AlfCompC(const void *el1, const void *el2)
{                                      /* for SortLL, case sensitive  */
  return strcasecmp(*(char * const *) el1, *(char * const *) el2);
}

