/*  author: G. Matas                           (g.matas@ee.surrey.ac.uk)
*/
/* +-------------------------------------------------------------------+ */
/* | Copyright 1992, George Matas.                                     | */
/* |   Permission to use, copy, modify, and distribute this software   | */
/* |   and its documentation for any purpose and without fee is hereby | */
/* |   granted, provided that the above copyright notice appear in all | */
/* |   copies and that both that copyright notice and this permission  | */
/* |   notice appear in supporting documentation.  This software is    | */
/* |   provided "as is" without express or implied warranty.           | */
/* +-------------------------------------------------------------------+
*/
/*-----------------------------------------------------------------------*/
static char sccsid[]="@(#)93/06/30 g.matas@ee.surrey.ac.uk 5.1 sort_ex1.c";



#include "LL.h"
#include "linkLL.h"

#include <stdio.h>                                   /* for printf, gets etc */
#include <string.h>                                        /* for strcmp etc */

/*------------------ LL library example ---------------------------------
    1.   Reads in a text file from the stdio  ( sort_ex  <file)
    2.   Sorts line in alphabetical order
    3.   Prints out line number + line

  DEMONSTRATES:
    a/  usage of a qsort that doesn't require to allocate and array
    b/  how to store structures in a list
    c/  how to store a string (not a pointer to it) in a list
-----------------------------------------------------------------------*/
/* UMIX specific (non-ANSI)  functions*/
int strcasecmp(char *, char *);
/*
void qsort_l2(t_LL list, int (*fcmp)(void *, void *));  was prototype 
*/

void qsort_l2(t_LL list, int (*fcmp)(void * s1, void * s2));



typedef struct { 
           int         line_no;
           char        text[300];
	   } elem ;

elem elm;
t_LL list;



void printlist(void);                                /* a kludge */
static int AlfComp(void  * el1, void  * el2)  /* for SortLL, case sensitive  */
{
  return strcmp(((elem*) el1)->text, ((elem*) el2)->text);
}

#if CASE_SENS
static int AlfCompC(void  * el1, void  * el2)  /* for SortLL, case sensitive  */
{
  return strcasecmp(((elem*) el1)->text, ((elem*)el2)->text);
}
#endif


int main(void)
{
  int line_num=0;
  elem  buffer;

  list = ConsLL();

  while(-1!=scanf("\n%[^\n]",&buffer.text)){
    buffer.line_no= ++line_num;
    InsLastLLf(list,sizeof(int)+strlen(buffer.text)+1,&buffer);  
  }

   fprintf(stderr,"qsort_l2 start -- ");
  qsort_l2(list, AlfComp);
    fprintf(stderr,"end\n");

  printlist();

  return 0;
}


void printlist(void)
{
  elem * pelm;

  ForeachLL_M(list,pelm)
    printf("%2d: %s\n", pelm->line_no, pelm->text);
  printf("\n\n");

}


/*-----------------------------------------------------------------------*/
/* The following code is a slightly modified version of qsort 
   posted to comp.lang.c by jjsc@inf.rl.ac.uk on behalf of
   GORMAN_B@P1.LANCSP.AC.UK
*/
void qsort_l2(t_LL li, int (*fcmp)(void *, void *)); /* was prototype */


int (*qsort_l2_cmp)(void * , void *); /* global, avoids repeated passing */

#define prev backward
#define next forward
#define LINKS l_list
/*****************************************************************************/

static void qsort_l2_swop(LINKS *s, LINKS *t)
	 /* assumes: s!=t && s->prev!=t */
/*****************************************************************************/

   {LINKS *r=s->prev, *u=t->next;                /* get surrounding pointers */
    (void) l_unlink(s); (void) l_unlink(t);    /* unlink list elements */
    l_lafter (r, t); l_lbefore(u, s);}          /* and re-link in new place */

/*
void qsort_l2_aux(left, right) LINKS *left, *right;
*/
static void qsort_l2_aux(l_list  * left, l_list * right)

   {while(left!=right)                  /* don't sort less than two elements */

       {LINKS *p=left=left->prev, *q=right;/* p is i, and q is j in the book */

        do {while(        (*qsort_l2_cmp)((p=p->next)+1, right+1)<0); /* scan left */
            while(p!=q && (*qsort_l2_cmp)((q=q->prev)+1, right+1)>0);/* scan right */
            if(p==q) break;                   /* stop when the pointers meet */
            qsort_l2_swop(p, q);          /* swop the two unordered elements */
               {LINKS *x=p; p=q; q=x;}}   /* then swop the pointers as well! */
        while(1);                                      /* and go round again */

        if(p!=right)

           {q=p->prev;     /* use q to hold pointer to logical position of p */
            qsort_l2_swop(p, right);   /* also effectively swops p and right */
            qsort_l2_aux(right->next, p);   /* so use them interchanged here */
            p=q->next;}                     /* and then restore p afterwards */

        if((left=left->next)==p) return; right=p->prev;}    /* non recursive */

    return;}


void qsort_l2(t_LL root, int (*fcmp)( void *, void * ))
{
   qsort_l2_cmp=fcmp;        /* assign once, to save copying at each level */
   qsort_l2_aux(list2link(root)->forward,list2link(root)->backward);

}      /* then sort the entire list */



